#include "stdafx.h"
#include "KeyInjectModule.h"
#include "KeyInjectModuleDlg.h"
#include "MSRItfUSBHID.h"
#include "IDT_DUKPT.h"
#include "Thread.h"
#include <time.h> 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString StrInitialKey = "0123456789ABCDEFFEDCBA9876543210";
CString StrReaderStatus = "Please Connect MagSwipe Reader!";

CEvent m_Event;

const TCHAR CR[] = {13, 0};
BYTE WResp;

BYTE glm_nksn[10];
BOOL bIK = false;
BOOL bUpdateDisplay = false;
BOOL bChecked = false;

CString StrHID_Data;
BYTE HID_Data[1024];
int HID_Data_Length;

CString StrUSBKB;
int USBKB_Data_Length;
BYTE USBKB_Data[10];

BYTE CardDataBuffer[1000];
int ResponseLength = 0;
ULONG BufferLength;

int EncodingType;
int nReader;

/**************************************************/
BYTE challenge[16];
BYTE KSNglb[10];
bool bActivation = false;
/**************************************************/

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUT };
	//}}AFX_DATA
	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
//{{AFX_MSG_MAP(CAboutDlg)
// No message handlers
//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg dialog

CKeyInjectModuleDlg::CKeyInjectModuleDlg(CWnd* pParent /*=NULL*/)
: CDialog(CKeyInjectModuleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKeyInjectModuleDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CKeyInjectModuleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKeyInjectModuleDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CKeyInjectModuleDlg, CDialog)
//{{AFX_MSG_MAP(CKeyInjectModuleDlg)
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
ON_BN_CLICKED(IDC_EXIT, OnExit)
ON_BN_CLICKED(IDC_SEND, OnSend)
ON_BN_CLICKED(IDC_SCRIPT, OnDecrypt)
ON_BN_CLICKED(IDC_INPUT_KEY, OnInputKey)
ON_COMMAND(ID_MENU_SetDefault, OnMENUSetDefault)
ON_COMMAND(ID_MENU_ReadConfiguration, OnMENUReadConfiguration)
ON_COMMAND(ID_MENU_ReadFirmware, OnMENUReadFirmware)
ON_COMMAND(ID_MENU_BeeperOff, OnMENUBeeperOff)
ON_COMMAND(ID_MENU_BeeperLow, OnMENUBeeperLow)
ON_COMMAND(ID_MENU_BeeperHigh, OnMENUBeeperHigh)
ON_COMMAND(ID_MENU_ReadBothDirections, OnMENUReadBothDirections)
ON_COMMAND(ID_MENU_ReadForwardDirection, OnMENUReadForwardDirection)
ON_COMMAND(ID_MENU_ReadBackwardDirection, OnMENUReadBackwardDirection)
ON_COMMAND(ID_MENU_About, OnMENUAbout)
ON_WM_TIMER()
ON_COMMAND(ID_MENU_TDES, OnMenuTdes)
ON_COMMAND(ID_MENU_AES, OnMenuAes)
ON_COMMAND(ID_MENU_SetPrePANClrDataID, OnMENUSetPrePANClrDataID)
ON_COMMAND(ID_MENU_SetPostPANClrDataID, OnMENUSetPostPANClrDataID)
ON_COMMAND(ID_MENU_SetMaskCharID, OnMENUSetMaskCharID)
ON_COMMAND(MSREnableID, OnMSREnableID)
ON_COMMAND(MSRDisableID, OnMSRDisableID)
ON_COMMAND(SecurityLevID, OnSecurityLevID)
ON_COMMAND(HIDIDTMode, OnHIDIDTMode)
ON_COMMAND(USBKBMode, OnUSBKBMode)
ON_COMMAND(ID_MENU_SetPollingInterval, OnMENUSetPollingInterval)
ON_COMMAND(ID_MENU_SetUK, OnMENUSetUK)
ON_COMMAND(ID_MENU_SetUniversal, OnMENUSetUniversal)
ON_COMMAND(Setpollinginterval1, OnSetpollinginterval1)
ON_COMMAND(GetDeviceSN, OnGetDeviceSN)
ON_BN_CLICKED(IDC_ACTAUTH, OnActauth)
ON_BN_CLICKED(IDC_ACTRPLY, OnActrply)
ON_BN_CLICKED(IDC_DEACTRPLY, OnDeactrply)
ON_BN_CLICKED(IDC_STATUS, OnStatus)
ON_COMMAND(ID_MENU_ForceEncryptAllTracks, OnMENUForceEncryptAllTracks)
ON_COMMAND(ID_MENU_NewEncryptionFormat, OnMENUNewEncryptionFormat)
ON_COMMAND(ID_MENU_OldEncryptionFormat, OnMENUOldEncryptionFormat)
	ON_BN_CLICKED(IDC_SYNCHRONIZE, OnSynchronize)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKeyInjectModuleDlg message handlers

BOOL CKeyInjectModuleDlg::OnInitDialog()
{
	
	CDialog::OnInitDialog();
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Add the Menu 
	m_menu.LoadMenu(IDR_MENU);
	SetMenu(&m_menu);
	
	// Timer interval = 500ms
	m_Timer = SetTimer(1, 500, 0);  

	// Decryption
	bDecryptMode = 0; // No Encryption

	// USB HID
	KBMode = 0;

	
	// Thread for reading track data
	CThread* pThread;
    pThread = new CThread();
    pThread->CreateThread();
    pThread->PostThreadMessage(WM_THREADMESSAGE,NULL,NULL);

	// Hide Decrypt button
	GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);

	// Reader Connection 
	m_font.CreatePointFont(120,"Arial");
	GetDlgItem(IDC_READER_STATUS)->SetFont(&m_font);
	GetDlgItem(IDC_READER_STATUS)->SetWindowText(StrReaderStatus);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CKeyInjectModuleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CKeyInjectModuleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CKeyInjectModuleDlg::SetToHex(const byte *inBuff,  byte *outBuff,int iLen)
{	
	int j=0;
	unsigned char* tempCh2 = NULL;
	tempCh2 = (unsigned char*)malloc(sizeof(BYTE)*3);
	for (int  i = 0 ; i < iLen/2 ;i++) 
	{
		memcpy(tempCh2,inBuff+i*2,2);
		*(tempCh2+2) = 0;
		j = static_cast<int>(strtol((char *)tempCh2,NULL, 16));
		*(outBuff + i)  = j;
	}
	free(tempCh2);
}

void CKeyInjectModuleDlg::FreeMem(unsigned char *pCh)
{
	if(pCh !=NULL)
		free(pCh);
	pCh = NULL;
}


//make the ASCII format Hex command to real hex commands.
//pcbCmd IN: the size of bysCmd buffer, OUT: the real bytes counts of the command
BOOL CKeyInjectModuleDlg::MakeCommand(CString& strCmd, PBYTE bysCmd, int* pcbCmd)
{	
	CString strTemp;
	BYTE byChkSum = 0;
	int nCount=0, nBufSize=0, i;
	
	if(bysCmd == NULL || *pcbCmd == NULL)
		return FALSE;
	nBufSize = *pcbCmd;
	
	strCmd.MakeUpper(); //Make the command upper case
	
	for (i=0; i<nBufSize/2; i++)
	{
		strTemp = strCmd.Left(2);
		bysCmd[i] = Char2Hex(strTemp[0]) << 4 | Char2Hex(strTemp[1]);		
		strCmd = strCmd.Right(nBufSize-2*i-2);
		nCount++;
	}
	
	*pcbCmd = nCount;
	
	return TRUE; 
}

// Get the Hex byte for matching char
BYTE CKeyInjectModuleDlg::Char2Hex(char ch) 
{
	if( ch >= '0' && ch <= '9')
		return BYTE(ch-'0');
	
	if(ch >= 'A' && ch <= 'F')
		return BYTE(ch-'A'+10);
	
	if(ch >= 'a' && ch <= 'f')
		return BYTE(ch-'a'+10);
	
	return 0;
}

byte CKeyInjectModuleDlg::asctohex(byte m, byte n)
{
	if(m>47 && m<58)
		m -= 48;
	else if (m>64 && m<91)
		m -= 55;
	else m -= 87;
	
	if(n>47 && n<58)
		n -= 48;
	else if (n>64 && n<91)
		n -= 55;
	else n -= 87;
	
	return (16*m+n);
	
}

byte CKeyInjectModuleDlg::asctodec(byte m, byte n)
{
	if(m>47 && m<58)
		m -= 48;
	else if (m>64 && m<91)
		m -= 55;
	else m -= 87;
	
	if(n>47 && n<58)
		n -= 48;
	else if (n>64 && n<91)
		n -= 55;
	else n -= 87;
	
	return (10*m+n);
	
}


void CKeyInjectModuleDlg::Decryption() 
{
	unsigned char  stringKSN[10];
	CString        message, strASCII, strHEX, strSessionID, strTmp;

	int i;
	
	strASCII = _T("Data in ASCII Format \r\n");
	strHEX = _T("\r\nData in HEX Format \r\n");
	strSessionID = _T("");
	message = _T("");
		
	memcpy(stringKSN, m_nksn,10);

	GetInitalKey(stringKSN, m_nderivation_key, m_ninitial_key);

	memset(m_cryptoKey, 0, 16);

	CurrentCryptoKey(0, m_ninitial_key, stringKSN, m_cryptoKey);

	
	if(m_CardType == 0){
		message = "Card Type: ISO/ABA\r\n";
	}else if (m_CardType == 1){
		message = "Card Type: AAMVA\r\n";
	}else if (m_CardType == 2){
		message = "Card Type: CADL\r\n";
	}else if (m_CardType == 3){
		message = "Card Type: Others\r\n";
	}
	

	if (EncodingType < 0x80)
	{
		// TDES Decryption
		if (bDecryptMode == 1)
		{
			unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

			if (bTrk1)
			{	
				TDES_Decryption(m_Track1Buffer, m_cryptoKey, init_vector, DataLen);
							
				// Display Decrypted ASCII Data
				for(i = 0; i < (int) DataLen; i++)					
				{
					strTmp.Format("%C", m_Track1Buffer[i]);
					strASCII += strTmp;
				}
			
				strASCII += "\r\n";

				// Display Decrypted HEX Data
				for(i = 0; i < (int) DataLen; i++)
				{
					strTmp.Format("%02X", m_Track1Buffer[i]);
					strHEX += strTmp;
				}
			}	
		}

		// AES Decryption
		else	
		{
			unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};				
			
			if (bTrk1)
			{	
				AES_Decryption(m_Track1Buffer, m_cryptoKey, init_vector, DataLen);
				
				// Display Decrypted ASCII Data
				for(i = 0; i < (int) DataLen; i++)					
				{
					strTmp.Format("%C", m_Track1Buffer[i]);
					strASCII += strTmp;
				}
			
				strASCII += "\r\n";
				// Display Decrypted HEX Data
				for(i = 0; i < (int) DataLen; i++)
				{
					strTmp.Format("%02X", m_Track1Buffer[i]);
					strHEX += strTmp;
				}
			}				
		}
		
		if (!KBMode) // USB HID
		{				
			if ((HID_Data[8]) && (EncodingType==0))
			{				
				for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
				{		
					strTmp.Format("%C",HID_Data[i]);
					strASCII+= strTmp;
				}
			}
		}					
		
		else	// USB KB
		{								
			if ((USBKB_Data[8]) && (EncodingType==0))
				strASCII += StrUSBKB.Mid(16+USBKB_Data[6]+USBKB_Data[7],USBKB_Data[8]);
			
			GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
			GetDlgItem(IDC_COMMAND)->SetFocus();				
		}
		
	
		if (bActivation) // Display Session ID
		{	
			strSessionID += _T("\r\nSession ID: ");
			

			if (!KBMode) // USB HID
			{
				for(i = HID_Data[6]+HID_Data[7]; i < HID_Data[6]+HID_Data[7]+8; i++)
				{
					strTmp.Format("%02X ", m_Track1Buffer[i]);
					strSessionID += strTmp;
				}				
			}
			
			else	// USB KB			
			{
				for(i = USBKB_Data[6]+USBKB_Data[7]; i < USBKB_Data[6]+USBKB_Data[7]+8; i++)
				{
					strTmp.Format("%02X ", m_Track1Buffer[i]);
					strSessionID += strTmp;
				}
			}
		}

	}
	

	
	else // if (EncodingType >= 0x80)
	{
		// TDES Decryption
		if (bDecryptMode == 1)	
		{
			unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};
			
			if (bTrk1)
			{
				TDES_Decryption(m_Track1Buffer, m_cryptoKey, init_vector, DataLen1);
				
				// Display Decrypted ASCII Data
				for(i = 0; i < (int) DataLen1; i++)
				{
					strTmp.Format("%C", m_Track1Buffer[i]);
					strASCII += strTmp;
				}			
				strASCII += "\r\n";

				// Display Decrypted HEX Data
				for(i = 0; i < (int) DataLen1; i++)
				{
					strTmp.Format("%02X", m_Track1Buffer[i]);
					strHEX += strTmp;
				}
				strHEX += "\r\n";
			}

			if (bTrk2)
			{	
				TDES_Decryption(m_Track2Buffer, m_cryptoKey, init_vector, DataLen2);
			
				// Display Decrypted ASCII Data
				for(i = 0; i < (int) DataLen2; i++)
				{
					strTmp.Format("%C", m_Track2Buffer[i]);
					strASCII += strTmp;
				}			
				strASCII += "\r\n";

				// Display Decrypted HEX Data
				for(i = 0; i < (int) DataLen2; i++)
				{
					strTmp.Format("%02X", m_Track2Buffer[i]);
					strHEX += strTmp;
				}
				strHEX += "\r\n";
			}

			if (bTrk3)
			{	
				TDES_Decryption(m_Track3Buffer, m_cryptoKey, init_vector, DataLen3);
				
				// Display Decrypted ASCII Data
				for(i = 0; i < (int) DataLen3; i++)
				{
					strTmp.Format("%C", m_Track3Buffer[i]);
					strASCII += strTmp;
				}			
				strASCII += "\r\n";

				// Display Decrypted HEX Data
				for(i = 0; i < (int) DataLen3; i++)
				{
					strTmp.Format("%02X", m_Track3Buffer[i]);
					strHEX += strTmp;
				}
				strHEX += "\r\n";
			}	


			if (bActivation) // Display Session ID
			{	
				strSessionID = "\r\nSession ID: ";
				TDES_Decryption(m_SessionIDBuffer, m_cryptoKey, init_vector, 8);
				
				// Display Decrypted Session ID
				for(i = 0; i < 8; i++)
				{
					strTmp.Format("%02X", m_SessionIDBuffer[i]);
					strSessionID += strTmp;
				}
			}	
		}
				
			
			
		// AES Decryption
		else if (bDecryptMode == 2)					
		{
			unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};	
					
			if (bTrk1)
			{
				AES_Decryption(m_Track1Buffer, m_cryptoKey, init_vector, DataLen1);
						
				// Display Decrypted ASCII Data
				for(i = 0; i < (int) DataLen1; i++)
				{
					strTmp.Format("%C", m_Track1Buffer[i]);
					strASCII += strTmp;
				}			
				strASCII += "\r\n";

				// Display Decrypted HEX Data
				for(i = 0; i < (int) DataLen1; i++)
				{
					strTmp.Format("%02X", m_Track1Buffer[i]);
					strHEX += strTmp;
				}
				strHEX += "\r\n";
			}

			if (bTrk2)
			{
				AES_Decryption(m_Track2Buffer, m_cryptoKey, init_vector, DataLen2);
		
				// Display Decrypted ASCII Data
				for(i = 0; i < (int) DataLen2; i++)
				{
					strTmp.Format("%C", m_Track2Buffer[i]);
					strASCII += strTmp;
				}			
				strASCII += "\r\n";

				// Display Decrypted HEX Data
				for(i = 0; i < (int) DataLen2; i++)
				{
					strTmp.Format("%02X", m_Track2Buffer[i]);
					strHEX += strTmp;
				}
				strHEX += "\r\n";
			}

			if (bTrk3)
			{	
				AES_Decryption(m_Track3Buffer, m_cryptoKey, init_vector, DataLen3);
				
				// Display Decrypted ASCII Data
				for(i = 0; i < (int) DataLen3; i++)
				{
					strTmp.Format("%C", m_Track3Buffer[i]);
					strASCII += strTmp;
				}			
				strASCII += "\r\n";

				// Display Decrypted HEX Data
				for(i = 0; i < (int) DataLen3; i++)
				{
					strTmp.Format("%02X", m_Track3Buffer[i]);
					strHEX += strTmp;
				}
				strHEX += "\r\n";
			}	


			if (bActivation) // Display Session ID
			{	
				strSessionID = "\r\nSession ID: ";
				AES_Decryption(m_SessionIDBuffer, m_cryptoKey, init_vector, 16);
				
				// Display Decrypted Session ID
				for(i = 0; i < 16; i++)
				{
					strTmp.Format("%02X", m_SessionIDBuffer[i]);
					strSessionID += strTmp;
				}
			}
		}
	

		if (KBMode) // USB KB
		{
			GetDlgItem(IDC_COMMAND)->SetWindowText(_T(""));
			GetDlgItem(IDC_COMMAND)->SetFocus();
		}				
	
	}
	
	// Key
	strTmp.Format("Key Value: %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X", \
		m_cryptoKey[0],m_cryptoKey[1],m_cryptoKey[2], m_cryptoKey[3],m_cryptoKey[4],\
		m_cryptoKey[5], m_cryptoKey[6], m_cryptoKey[7],m_cryptoKey[8],m_cryptoKey[9],\
		m_cryptoKey[0x0a], m_cryptoKey[0x0b],m_cryptoKey[0x0c], \
		m_cryptoKey[0x0d], m_cryptoKey[0x0e], m_cryptoKey[0x0f]);
	
	message += strTmp;
	
	// KSN
	strTmp.Format("\r\nKSN: %02X %02X %02X %02X %02X %02X %02X %02X %02X %02X", \
		glm_nksn[0],glm_nksn[1],glm_nksn[2], glm_nksn[3],glm_nksn[4],\
		glm_nksn[5], glm_nksn[6], glm_nksn[7],glm_nksn[8],glm_nksn[9]);
	
	message += strTmp;

	// Display Session ID
	if (bActivation)
		message += strSessionID;


	if ((EncodingType==4)||(EncodingType==84))
		message += "\r\n\r\nDecrypted Data:\r\n" + strHEX;
	else
		message += "\r\n\r\nDecrypted Data:\r\n" + strASCII + "\r\n" + strHEX;

	((CStatic *)GetDlgItem(IDC_RESP)) -> SetWindowText(message);
		
}

void CKeyInjectModuleDlg::Received_HID_Data() 
{
	bUpdateDisplay = true;
}


void CKeyInjectModuleDlg::OnTimer(UINT nIDEvent) 
{
	
	CheckReaderConnection();
	GetDlgItem(IDC_READER_STATUS)->SetWindowText(StrReaderStatus);

	if(bUpdateDisplay)
	{
		bUpdateDisplay = false;
		OnDecrypt();
	}

	CDialog::OnTimer(nIDEvent);
}


void CKeyInjectModuleDlg::OnInputKey() 
{
	int i;

	m_KeyDlg.m_BDK = "";
	m_KeyDlg.DoModal();	
		
	if(m_KeyDlg.m_BDK.GetLength() <32)
	{
		MessageBox("Key Length is less than 16 byte (32 character) long!","Error");
		return;
	}

	for (i=0; i<32; i++)
		m_nderivation_key[i] = asctohex(m_KeyDlg.m_BDK.GetAt(2*i),m_KeyDlg.m_BDK.GetAt(2*i+1));

	bIK = true;
}

void CKeyInjectModuleDlg::OnSend() 
{
	int nSize,i, j, End;
	BOOL bRet=TRUE;
	BYTE CmdBuf[500], CmdBuf2[503], LRC = 0;
	CString		StrResponse, StrTmp;
	unsigned long RespLen = 3;
	
	INTERFACE_TYPE emMyItfType; 
	ULONG emMyItfType1; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName;
	int		m_ulDevIndex = 0;
	
	emMyItfType1 = '1';
	emMyItfType2 = ITF_TYPE_USB_HID;

	BufferLength = 1000;
	
	
	CMSRItfUSBHID	MSR(emMyItfType2);
	for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)			
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(1); // make sure the device is not busy.
					
					//get command text
					GetDlgItem(IDC_COMMAND)->GetWindowText(StrCommand);
					
					StrCommand.Remove(_T(' ')); //remove space
					StrCommand.Remove(_T('\t')); //remove tab
					
					
					if(StrCommand.IsEmpty())  // Check if the command string is empty
					{
						MessageBox(_T("Please Input the Command String!"), _T("Error"), MB_OK);
						goto EXIT;
					}
					
					nSize = StrCommand.GetLength();
					
					// Convert the command to hex formart
					bRet = MakeCommand(StrCommand, CmdBuf, &nSize);
					
					if(bRet == FALSE)
					{
						MessageBox(_T("The command text is too long or invalid!"), _T("Error"), MB_OK);
						goto EXIT;
					}
					
					
					CmdBuf2[0] = 2;
					
					for(i=0; i<nSize; i++)
						CmdBuf2[i+1] = CmdBuf[i];
					
					CmdBuf2[i+1] = 3;
					
					for(i=0; i<nSize+2; i++)
						LRC ^= CmdBuf2[i];
					
					CmdBuf2[i] = LRC;
					
					
					nSize = i+1;
					
					MSR.SendCommand(CmdBuf2, nSize, CardDataBuffer, &BufferLength);
					
					MSR.CloseMSRDevice();
				}
				
				else
				{
					printf("Fail to open device! \n");
					MSR.CloseMSRDevice();
				}
			}
		}
	}
	
	if(m_ulDevIndex >= 50){
		emMyItfType2 = ITF_TYPE_USB_HID_KB;
		
		CMSRItfUSBHID	MSR(emMyItfType2);
		for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{
						Sleep(1); // make sure the device is not busy.
						
						//get command text
						GetDlgItem(IDC_COMMAND)->GetWindowText(StrCommand);
						
						StrCommand.Remove(_T(' ')); //remove space
						StrCommand.Remove(_T('\t')); //remove tab
						
						
						if(StrCommand.IsEmpty())  // Check if the command string is empty
						{
							MessageBox(_T("Please Input the Command String!"), _T("Error"), MB_OK);
							goto EXIT;
						}
						
						nSize = StrCommand.GetLength();
						
						// Convert the command to hex formart
						bRet = MakeCommand(StrCommand, CmdBuf, &nSize);
						
						if(bRet == FALSE)
						{
							MessageBox(_T("The command text is too long or invalid!"), _T("Error"), MB_OK);
							goto EXIT;
						}
						
						CmdBuf2[0] = 2;
						
						for(i=0; i<nSize; i++)
							CmdBuf2[i+1] = CmdBuf[i];
						
						CmdBuf2[i+1] = 3;
						
						for(i=0; i<nSize+2; i++)
							LRC ^= CmdBuf2[i];
						
						CmdBuf2[i] = LRC;
						
						
						nSize = i+1;
						
						MSR.SendCommand(CmdBuf2, nSize, CardDataBuffer, &BufferLength);
						//MSR.SendCommand2(CmdBuf2, nSize, StrResponse);

						MSR.CloseMSRDevice();
					}
					
					else
					{
						printf("Fail to open device! \n");
						MSR.CloseMSRDevice();
					}
				}
			}
		}		
	}
	
	
EXIT:
	{
		
	}
//	MSR.CloseMSRDevice();

		// Show command text
	StrResponse = _T("CMD: ");
	for (i=0; i<nSize; i++)
	{
		StrTmp.Format("%02X ", CmdBuf2[i]);
		StrResponse += StrTmp;
	}

	// MiniMag series with NAK package
	if ((nReader == 3) || (nReader == 6) || (nReader == 8))
	{
		for (i=BufferLength; i>0; i--)
		{
			// NAK package
			if ((CardDataBuffer[i-8] == 0x15) && (CardDataBuffer[i-7] == 0) && (CardDataBuffer[i-6] == 0) && (CardDataBuffer[i-5] == 0)
				 && (CardDataBuffer[i-4] == 0) && (CardDataBuffer[i-3] == 0) && (CardDataBuffer[i-2] == 0) && (CardDataBuffer[i-1] == 0))
			{				
				i = i-7;
			}

			else if (CardDataBuffer[i-1] != 0)
			{
				End = i;
				break;
			}
		}

	}
	
	else
	{
		for (i=BufferLength; i>0; i--)
		{
			if (CardDataBuffer[i-1] != 0)
			{
				End = i;
				break;
			}
		}
	}

	ResponseLength = End;

	// Output all response
	StrResponse += _T("\r\nOUT: ");
	
	for (j=0; j<ResponseLength; j++)
	{
		StrTmp.Format("%02X ",CardDataBuffer[j]);
		StrResponse += StrTmp;
	}

	GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);


	/*
	StrCommand = "";
	for (i=0; i<nSize; i++)
	{
		StrTmp.Format("%02X ", CmdBuf2[i]);
		StrCommand += StrTmp;
	}
	StrResponse = "CMD: " + StrCommand + "\r\nOUT: " + StrResponse;
	
	GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	
	StrCommand = "";
	GetDlgItem(IDC_COMMAND)->SetWindowText(StrCommand);
	*/
}

void CKeyInjectModuleDlg::OnDecrypt() 
{
	const TCHAR CR[] = {13, 0};
	BOOL bDecryption = false;
	
	unsigned char len = 0;
	unsigned char berror = 0;
	unsigned long counter;
	CString StringTmp, StrTmp;
	
	bTrk1 = bTrk2 = bTrk3 = false;
	
	int i;
	int EncryptedTrackLength = 0;
	int EncryptedTrack1Length = 0;
	int EncryptedTrack2Length = 0;
	int EncryptedTrack3Length = 0;
		
	int UnencryptedLength = 0;	
	int shiftSize = 0;
	

	if (bDecryptMode)
	{
		if (!KBMode) // USB HID
		{

			int Length;		
			BYTE TempLRC=0;
			BYTE TempCheckSum=0;
			CString StrTemp;
			
		
			// Check Length
			Length = HID_Data[3]*256 + HID_Data[2];	

			StrTemp.Format("Length error!\r\nLength from Data: %04X\r\nCalculated Length: %04X",Length, HID_Data_Length-7);

	      	if ( Length != HID_Data_Length-7)
				MessageBox(StrTemp);


			// LRC
			for (i=4; i<HID_Data_Length-3; i++)
				TempLRC ^= HID_Data[i];

			StrTemp.Format("LRC error!\r\nLRC from Data: %04X\r\nCalculated LRC: %04X",HID_Data[HID_Data_Length-3], TempLRC);
			
			if (TempLRC != HID_Data[HID_Data_Length-3])
				MessageBox(StrTemp);


			// CheckSum
			for (i=4; i<HID_Data_Length-3; i++)
				TempCheckSum += HID_Data[i];
			
			StrTemp.Format("CheckSum error!\r\nCheckSum from Data: %04X\r\nCalculated CheckSum: %04X",HID_Data[HID_Data_Length-2], TempCheckSum);

			if (TempCheckSum != HID_Data[HID_Data_Length-2])
				MessageBox(StrTemp);


			EncodingType = HID_Data[4];

			if (EncodingType < 0x80)
			{

				// Non ISO/ABA Data Output Format
				if ((EncodingType == 1) || (EncodingType == 3))
				{
					StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}
					
					
					StrTmp += "\r\n\r\nCard Data:\r\n";
					if (HID_Data[6])
					{				
						for (i=0; i<HID_Data[6]; i++)
						{		
							StringTmp.Format("%C",HID_Data[i+9]);
							StrTmp += StringTmp;
						}
					}
					
					if (HID_Data[7])
					{				
						for (i=HID_Data[6]+9; i<HID_Data[6]+HID_Data[7]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}
					
					
					if (HID_Data[8])
					{				
						for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}
					
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
					
					StrTmp = "";        
					GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
				}
				
				// ISO/ABA Data Output Format
				else if (EncodingType == 0)				
				{
					StrTmp += "Reader Output: (ISO/ABA Data Output Format)";
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];
					
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}
					
					
					StrTmp += "\r\n\r\nMasked Data: ";
					if (HID_Data[6])
					{	
						StrTmp += "\r\nTrack 1: ";
						
						for (i=0; i<HID_Data[6]; i++)
						{		
							StringTmp.Format("%C",HID_Data[i+9]);
							StrTmp += StringTmp;
						}
					}
					
					if (HID_Data[7])
					{
						StrTmp += "\r\nTrack 2: ";
						
						for (i=HID_Data[6]+9; i<HID_Data[6]+HID_Data[7]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}
					
					if (HID_Data[8])
					{
						StrTmp += "\r\nTrack 3: ";
						
						for (i=HID_Data[6]+HID_Data[7]+9; i<HID_Data[6]+HID_Data[7]+HID_Data[8]+9; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
					}
					
					
					UnencryptedLength = HID_Data[6]+HID_Data[7]+HID_Data[8];


					// Security Level=4
					if (bActivation)
						shiftSize = 8;
					else
						shiftSize = 0;
		

					if (bDecryptMode == 1) // TDES
					{
						if (((HID_Data[6] + HID_Data[7]+shiftSize) % 8) == 0)
							EncryptedTrackLength = HID_Data[6] + HID_Data[7]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6] + HID_Data[7]+shiftSize) / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if (((HID_Data[6] + HID_Data[7]+shiftSize) % 16) == 0)
							EncryptedTrackLength = HID_Data[6] + HID_Data[7]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6] + HID_Data[7]+shiftSize) / 16 + 1) * 16;
					}
					
					DataLen = EncryptedTrackLength;
					
					for (i = 0; i<EncryptedTrackLength; i++)
						m_Track1Buffer[i] = HID_Data[i+UnencryptedLength+9];
					
					bTrk1 = true;
					bDecryption = true;	
					
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
					
					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					//Initial key
					if (!bIK)
					{
						m_str_initial_key = StrInitialKey;
						len = m_str_initial_key.GetLength();
						
						for(i=0; i<len/2; i++)							
							m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
					}
					
					
					counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
					if(!counter) 
					{
						berror = 1;
						MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
					}				
												
					Decryption();
				}


				// Raw Data Output Format
				else if (EncodingType == 4)				
				{
					StrTmp += "Reader Output: (Raw Data Output Format)";
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];
					
					for (i=1; i<HID_Data_Length; i++)
					{		
						StringTmp.Format("%02X",HID_Data[i]);
						StrTmp += StringTmp;
					}				
					
					int UnencryptedLength = HID_Data[6]+HID_Data[7]+HID_Data[8];
				
					// Security Level=4
					if (bActivation)
						shiftSize = 8;
					else
						shiftSize = 0;
		

					if (bDecryptMode == 1) // TDES
					{
						if (((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) % 8) == 0)
							EncryptedTrackLength = HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if (((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) % 16) == 0)
							EncryptedTrackLength = HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize;
						else
							EncryptedTrackLength = ((HID_Data[6]+HID_Data[7]+HID_Data[8]+shiftSize) / 16 + 1) * 16;
					}
					
					DataLen = EncryptedTrackLength;
					
					for (i = 0; i<EncryptedTrackLength; i++)
						m_Track1Buffer[i] = HID_Data[i+9];
					
					bTrk1 = true;
					bDecryption = true;	
					
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
					
					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					//Initial key
					if (!bIK)
					{
						m_str_initial_key = StrInitialKey;
						len = m_str_initial_key.GetLength();
						
						for(i=0; i<len/2; i++)							
							m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
					}
																							
					Decryption();
				}

			}


			else // if (EncodingType >= 0x80)
			{

				// Non ISO/ABA Data Output Format
				if ((EncodingType == 0x81) || (EncodingType == 0x83))				
					StrTmp = "Reader Output: (Non ISO/ABA Enhanced Data Output Format)\r\n";

				else if (EncodingType == 0x80)
					StrTmp = "Reader Output: (ISO/ABA Enhanced Data Output Format)\r\n";

				else if (EncodingType == 0x84)
					StrTmp = "Reader Output: (Enhanced RAW Data Output Format)\r\n";

				for (i=1; i<HID_Data_Length; i++)
				{		
					StringTmp.Format("%02X",HID_Data[i]);
					StrTmp += StringTmp;
				}
					



				/*
					Clear/mask data sent status byte:
					bit 0: 1--- if TK1 clear/mask data present 
					bit 1: 1--- if TK2 clear/mask data present
					bit 2: 1--- if TK3 clear/mask data present
					Bit 3:0-0
					Bit 4:0-0
					Bit 5:0-0
				*/
				BYTE bClearMaskDataStatus = HID_Data[9];
							

					
			
					/*
						Encrypted data sent status
						bit 0: if 1-tk1 encrypted data present 
						bit 1: if 1-tk2 encrypted data present
						bit 2: if 1-tk3 encrypted data present
						bit 3: if 1-tk1 hash data present
						bit 4: if 1-tk2 hash data present
						bit 5: if 1-tk3 hash data present
						Bit 6: if 1-session ID present 
						Bit 7: if 1-KSN present
					*/
				BYTE bEncryptedDataStatus = HID_Data[10];		
					
				if (bClearMaskDataStatus)
					StrTmp += "\r\n\r\nMasked Data: ";			
					

				if (HID_Data[6])
				{
					if (bClearMaskDataStatus & 1)
					{	
						StrTmp += "\r\nTrack 1: ";
						
						for (i=0; i<HID_Data[6]; i++)
						{		
							StringTmp.Format("%C",HID_Data[i+11]);
							StrTmp += StringTmp;
						}

						UnencryptedLength += HID_Data[6];
					}

					bTrk1 = true;
					if (bDecryptMode == 1) // TDES
					{
						if ((HID_Data[6] % 8) == 0)
							EncryptedTrack1Length = HID_Data[6];
						else
							EncryptedTrack1Length = (HID_Data[6] / 8 + 1) * 8;
					}
					
					else if (bDecryptMode == 2) // AES
					{
						if ((HID_Data[6] % 16) == 0)
							EncryptedTrack1Length = HID_Data[6];
						else
							EncryptedTrack1Length = (HID_Data[6] / 16 + 1) * 16;
					}
					

					DataLen1 = EncryptedTrack1Length;
				}
				
				
						
				if (HID_Data[7])
				{
					if (bClearMaskDataStatus & 2)
					{
						StrTmp += "\r\nTrack 2: ";
						
						for (i=UnencryptedLength+11; i<UnencryptedLength+HID_Data[7]+11; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
						UnencryptedLength += HID_Data[7];
					}

					if(bEncryptedDataStatus & 2)
					{
						bTrk2 = true;
	
						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[7] % 8) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[7] % 16) == 0)
								EncryptedTrack2Length = HID_Data[7];
							else
								EncryptedTrack2Length = (HID_Data[7] / 16 + 1) * 16;
						}

						DataLen2 = EncryptedTrack2Length;
					}
					
				}
				
						
				if (HID_Data[8])
				{						

					if (bClearMaskDataStatus & 4)
					{
						StrTmp += "\r\nTrack 3: ";
						
						for (i=UnencryptedLength+11; i<UnencryptedLength+HID_Data[8]+11; i++)
						{		
							StringTmp.Format("%C",HID_Data[i]);
							StrTmp += StringTmp;
						}
						UnencryptedLength += HID_Data[8];
					}

					if(bEncryptedDataStatus & 4)
					{
						bTrk3 = true;

						if (bDecryptMode == 1) // TDES
						{
							if ((HID_Data[8] % 8) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 8 + 1) * 8;
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if ((HID_Data[8] % 16) == 0)
								EncryptedTrack3Length = HID_Data[8];
							else
								EncryptedTrack3Length = (HID_Data[8] / 16 + 1) * 16;
						}		

						DataLen3 = EncryptedTrack3Length;
					}
				}
	
				if (bTrk1)
					for (i = 0; i<EncryptedTrack1Length; i++)
						m_Track1Buffer[i] = HID_Data[i+UnencryptedLength+11];

				if (bTrk2)
					for (i = 0; i<EncryptedTrack2Length; i++)
						m_Track2Buffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+11];

				
				if (bTrk3)
					for (i = 0; i<EncryptedTrack3Length; i++)
						m_Track3Buffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+11];

				// Security Level=4
				if (bActivation)
				{	
					if (bDecryptMode == 1) // TDES
					{
						for (i = 0; i<8; i++)
							m_SessionIDBuffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
					}
					
					else if (bDecryptMode == 2) // AES
					{
						for (i = 0; i<16; i++)
							m_SessionIDBuffer[i] = HID_Data[i+UnencryptedLength+EncryptedTrack1Length+EncryptedTrack2Length+EncryptedTrack3Length+11];
					}
				}
					

				if ((bTrk1)||(bTrk2)||(bTrk3))
				{
					for (i=0; i<10; i++)
						glm_nksn[i] = HID_Data[i+HID_Data_Length-13];

			
					bDecryption = true;	
					
					GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
					
					
					for(i=0; i<10; i++)	
						m_nksn[i] = glm_nksn[i];			
					
					//Initial key
					if (!bIK)
					{
						m_str_initial_key = StrInitialKey;
						len = m_str_initial_key.GetLength();
						
						for(i=0; i<len/2; i++)							
							m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
					}
					
					Decryption();
				}
				
			}
		}
		
		else	// USB KB
		{
			
			GetDlgItem(IDC_COMMAND)->GetWindowText(StrUSBKB);
			USBKB_Data_Length = StrUSBKB.GetLength();
			
			if (USBKB_Data_Length > 0)
			{		
				
				int Length;
				BYTE TempData[1000];
				BYTE TempLRC=0;
				BYTE TempCheckSum=0;
				CString StrTemp;
				
				for (i=0; i<10; i++)
					USBKB_Data[i+1] = asctohex(StrUSBKB.GetAt(2*i),StrUSBKB.GetAt(2*i+1));


				// Check Length
				Length = USBKB_Data[3]*256 + USBKB_Data[2];	

				StrTemp.Format("Length error!\r\nLength from Data: %04X\r\nCalculated Length: %04X",Length, USBKB_Data_Length-12);

				if ( Length != USBKB_Data_Length-12)
					MessageBox(StrTemp);


				for (i=0; i<USBKB_Data_Length; i++)
					TempData[i] = StrUSBKB.GetAt(i);


				// LRC
				for (i=6; i<USBKB_Data_Length-6; i++)
					TempLRC ^= TempData[i];

				StrTemp.Format("LRC error!\r\nLRC from Data: %04X\r\nCalculated LRC: %04X",asctohex(StrUSBKB.GetAt(USBKB_Data_Length-6),StrUSBKB.GetAt(USBKB_Data_Length-5)), TempLRC);
				
				if (TempLRC != asctohex(StrUSBKB.GetAt(USBKB_Data_Length-6),StrUSBKB.GetAt(USBKB_Data_Length-5)))
					MessageBox(StrTemp);


				// CheckSum
				for (i=6; i<USBKB_Data_Length-6; i++)
					TempCheckSum += TempData[i];
				
				StrTemp.Format("CheckSum error!\r\nCheckSum from Data: %04X\r\nCalculated CheckSum: %04X",asctohex(StrUSBKB.GetAt(USBKB_Data_Length-4),StrUSBKB.GetAt(USBKB_Data_Length-3)), TempCheckSum);

				if (TempCheckSum != asctohex(StrUSBKB.GetAt(USBKB_Data_Length-4),StrUSBKB.GetAt(USBKB_Data_Length-3)))
					MessageBox(StrTemp);
	

				EncodingType = USBKB_Data[4];

				if (EncodingType < 0x80)
				{
					// Non ISO/ABA Data Output Format
					if ((EncodingType == 1) || (EncodingType == 3))
					{
						StrTmp = "Reader Output: (Non ISO/ABA Data Output Format)\r\n";																
						
						if (USBKB_Data[6])										
							StrTmp += StrUSBKB.Mid(16,USBKB_Data[6]);						
						
						if (USBKB_Data[7])
							StrTmp += StrUSBKB.Mid(16+USBKB_Data[6],USBKB_Data[7]);						
							
						if (USBKB_Data[8])
							StrTmp += StrUSBKB.Mid(16+USBKB_Data[6]+USBKB_Data[7],USBKB_Data[8]);		
						
											
						GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
						
						StrTmp = "";        
						GetDlgItem(IDC_RESP) -> SetWindowText(StrTmp);
					}
			
					// ISO/ABA Data Output Format
					else if (EncodingType == 0)				
					{			
						// Security Level=4
						if (bActivation)
							shiftSize = 8;
						else
							shiftSize = 0;
							
						if (bDecryptMode == 1) // TDES
						{
							if (((USBKB_Data[6]+USBKB_Data[7]+shiftSize)%8) == 0)
								EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+shiftSize)/8 + 1)*8; 
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if (((USBKB_Data[6]+USBKB_Data[7]+shiftSize)%16) == 0)
								EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+shiftSize)/16 + 1)*16; 
							
						}
						
						DataLen = EncryptedTrackLength;

						UnencryptedLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8];
						
						for (i = 0; i<EncryptedTrackLength; i++)
							m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+16+2*i),StrUSBKB.GetAt(UnencryptedLength+17+2*i));
						
						
						for (i=0; i<10; i++)			
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));
							
							
						bTrk1 = true;
						bDecryption = true;	
						
						for(i=0; i<10; i++)	
							m_nksn[i] = glm_nksn[i];			
						
						//Initial key
						if (!bIK)
						{
							m_str_initial_key = StrInitialKey;
							len = m_str_initial_key.GetLength();
							
							for(i=0; i<len/2; i++)							
								m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
						}
												
						counter = m_nksn[9] | (m_nksn[8] << 8) | ((m_nksn[7] & 0x1f) << 16) ;
						if(!counter) 
						{
							berror = 1;
							MessageBox("The KSN can not be 0", "Warning", MB_ICONWARNING);			
						}
						
						GetInitalKey(m_nksn, m_nderivation_key, m_ninitial_key);
						//GetIK(m_nksn, m_nderivation_key, m_ninitial_key, ET_TDES_DUKPT);
						
						Decryption();
						
					}


					// Raw Data Output Format
					else if (EncodingType == 4)				
					{			
						// Security Level=4
						if (bActivation)
							shiftSize = 8;
						else
							shiftSize = 0;
							
						if (bDecryptMode == 1) // TDES
						{
							if (((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)%8) == 0)
								EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)/8 + 1)*8; 
						}
						
						else if (bDecryptMode == 2) // AES
						{
							if (((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)%16) == 0)
								EncryptedTrackLength = USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize;
							else
								EncryptedTrackLength = ((USBKB_Data[6]+USBKB_Data[7]+USBKB_Data[8]+shiftSize)/16 + 1)*16; 
							
						}
						
						DataLen = EncryptedTrackLength;
						
						for (i = 0; i<EncryptedTrackLength; i++)
							m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(16+2*i),StrUSBKB.GetAt(17+2*i));
						
						
						for (i=0; i<10; i++)			
							glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));
							
							
						bTrk1 = true;
						bDecryption = true;	
						
						for(i=0; i<10; i++)	
							m_nksn[i] = glm_nksn[i];			
						
						//Initial key
						if (!bIK)
						{
							m_str_initial_key = StrInitialKey;
							len = m_str_initial_key.GetLength();
							
							for(i=0; i<len/2; i++)							
								m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
						}
											
						Decryption();
						
					}
				}



				else // if (EncodingType >= 0x80)
				{
					// Non ISO/ABA Data Output Format
					if ((EncodingType == 0x81) || (EncodingType == 0x83))
						StrTmp = "Reader Output: (Non ISO/ABA Enhanced Data Output Format)\r\n";			

					else if (EncodingType == 0x80)
						StrTmp = "Reader Output: (ISO/ABA Enhanced Data Output Format)\r\n";			

					else if (EncodingType == 0x84)
						StrTmp = "Reader Output: (Enhanced RAW Data Output Format)\r\n";			

							
					/*
						Clear/mask data sent status byte:
						bit 0: 1--- if TK1 clear/mask data present 
						bit 1: 1--- if TK2 clear/mask data present
						bit 2: 1--- if TK3 clear/mask data present
						Bit 3:0-0
						Bit 4:0-0
						Bit 5:0-0
					*/
					BYTE bClearMaskDataStatus = USBKB_Data[9];


					/*
						Encrypted data sent status
						bit 0: if 1-tk1 encrypted data present 
						bit 1: if 1-tk2 encrypted data present
						bit 2: if 1-tk3 encrypted data present
						bit 3: if 1-tk1 hash data present
						bit 4: if 1-tk2 hash data present
						bit 5: if 1-tk3 hash data present
						Bit 6: if 1-session ID present 
						Bit 7: if 1-KSN present
					*/
					BYTE bEncryptedDataStatus = USBKB_Data[10];		
				
					if ((bEncryptedDataStatus & 0x07) > 0)
					{				

						if (bClearMaskDataStatus & 1)
							UnencryptedLength += USBKB_Data[6];

						if (bClearMaskDataStatus & 2)
							UnencryptedLength += USBKB_Data[7];

						if (bClearMaskDataStatus & 4)
							UnencryptedLength += USBKB_Data[8];
						

						if (bEncryptedDataStatus & 1)
						{
							bTrk1 = true;													

							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[6] % 8) == 0)
									EncryptedTrack1Length = USBKB_Data[6];
								else
									EncryptedTrack1Length = (USBKB_Data[6] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[6] % 16) == 0)
									EncryptedTrack1Length = USBKB_Data[6];
								else
									EncryptedTrack1Length = (USBKB_Data[6] / 16 + 1) * 16;
							}
							
							for (i = 0; i<EncryptedTrack1Length; i++)
								m_Track1Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+20+2*i),StrUSBKB.GetAt(UnencryptedLength+21+2*i));
								
							DataLen1 = EncryptedTrack1Length;
							
						}													

					

						if (bEncryptedDataStatus & 2)
						{
							bTrk2 = true;
							
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[7] % 8) == 0)
									EncryptedTrack2Length = USBKB_Data[7];
								else
									EncryptedTrack2Length = (USBKB_Data[7] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[7] % 16) == 0)
									EncryptedTrack2Length = USBKB_Data[7];
								else
									EncryptedTrack2Length = (USBKB_Data[7] / 16 + 1) * 16;
							}

							for (i = 0; i<EncryptedTrack2Length; i++)
								m_Track2Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+21+2*i));

							DataLen2 = EncryptedTrack2Length;
							
						}								
						

	
							
						if (bEncryptedDataStatus & 4)
						{
							bTrk3 = true;
							
							if (bDecryptMode == 1) // TDES
							{
								if ((USBKB_Data[8] % 8) == 0)
									EncryptedTrack3Length = USBKB_Data[8];
								else
									EncryptedTrack3Length = (USBKB_Data[8] / 8 + 1) * 8;
							}
							
							else if (bDecryptMode == 2) // AES
							{
								if ((USBKB_Data[8] % 16) == 0)
									EncryptedTrack3Length = USBKB_Data[8];
								else
									EncryptedTrack3Length = (USBKB_Data[8] / 16 + 1) * 16;
							}
		
							for (i = 0; i<EncryptedTrack3Length; i++)
								m_Track3Buffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+21+2*i));

							DataLen3 = EncryptedTrack3Length;
						}

						// Security Level=4
						if (bActivation)
						{	
							if (bDecryptMode == 1) // TDES
							{
								for (i = 0; i<8; i++)
									m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
							}
							
							else if (bDecryptMode == 2) // AES
							{
								for (i = 0; i<16; i++)
									m_SessionIDBuffer[i] = asctohex(StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+20+2*i),StrUSBKB.GetAt(UnencryptedLength+EncryptedTrack1Length*2+EncryptedTrack2Length*2+EncryptedTrack3Length*2+21+2*i));
							}
						}
						
			
						if ((bTrk1)||(bTrk2)||(bTrk3))
						{
							for (i=0; i<10; i++)			
								glm_nksn[i] = asctohex(StrUSBKB.GetAt(USBKB_Data_Length-26+2*i),StrUSBKB.GetAt(USBKB_Data_Length-25+2*i));
								
						
							bDecryption = true;	
							
							for(i=0; i<10; i++)	
								m_nksn[i] = glm_nksn[i];			
							
							//Initial key
							if (!bIK)
							{
								m_str_initial_key = StrInitialKey;
								len = m_str_initial_key.GetLength();
								
								for(i=0; i<len/2; i++)							
									m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
							}
													
							
							Decryption();
						}
							
						
					}
		
				}
			

			}
		}
	}

		
	else
	{
		if (!KBMode)	// ID Tech USB HID Mode
		{
			if ((nReader == 1) || (nReader == 2) || (nReader == 3))
			{
				for (i=10; i<HID_Data_Length; i++)
				{		
					if (HID_Data[i] == 13)
						StrTmp += "\r\n";		
					else
					{
						StringTmp.Format("%C",(BYTE)HID_Data[i]);
						StrTmp += StringTmp;		
					}
				}
				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
			}


			else if (nReader == 7)	
			{
				for (i=8; i<HID_Data_Length; i++)
				{		
					if (HID_Data[i] == 13)
						StrTmp += "\r\n";		
					else
					{
						StringTmp.Format("%C",(BYTE)HID_Data[i]);
						StrTmp += StringTmp;		
					}
				}
				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
			}

			// Unknown reader type
			else
			{
				for (i=0; i<HID_Data_Length; i++)
				{		
					if (HID_Data[i] == 13)
						StrTmp += "\r\n";		
					else
					{
						StringTmp.Format("%C",(BYTE)HID_Data[i]);
						StrTmp += StringTmp;		
					}
				}
				GetDlgItem(IDC_COMMAND)->SetWindowText(StrTmp);
			}
	
		}
		
	}

}

void CKeyInjectModuleDlg::OnExit() 
{
	OnOK();
}


bool CKeyInjectModuleDlg::SendCommandRequest(byte* datapool, int outLength)
{

	CString strDevName, StrResponse, StrTmp;
	int	m_ulDevIndex = 0;
	int i, j, End;
	bool isFound = false;
	bool cmdSucceed = false;

	BufferLength = 1000;

	INTERFACE_TYPE emMyItfType; 
	INTERFACE_TYPE emMyItfType2;

	emMyItfType2 = ITF_TYPE_USB_HID;
	CMSRItfUSBHID MSR(emMyItfType2);

	// Initiate all values
	for (i=0; i<(int) BufferLength; i++)
		CardDataBuffer[i] = 0;

	// Scan for device interface
	for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{
					Sleep(1); // make sure the device is not busy

						// SM USB HID		 VM USB HID		 VM MT USB HID
					if ((nReader == 1) || (nReader == 2) || (nReader == 7))
						MSR.SendCommand(datapool, outLength, CardDataBuffer, &BufferLength);

							// MM USB HID		 MM MT USB HID
					else if ((nReader == 3) || (nReader == 8))
						MSR.SendCommand_MM(datapool, outLength, CardDataBuffer, &BufferLength);
				
					isFound = true;

					MSR.CloseMSRDevice();

					break;
				}
			}
		}
	}
	
	if(!isFound)
	{
		emMyItfType2 = ITF_TYPE_USB_HID_KB;
		
		CMSRItfUSBHID MSR(emMyItfType2);

		for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{
						Sleep(1); // make sure the device is not busy.
		
							// SM USB KB		 VM USB KB
						if ((nReader == 4) || (nReader == 5))
							MSR.SendCommand(datapool, outLength, CardDataBuffer, &BufferLength);

								// MM USB KB
						else if (nReader == 6)
							MSR.SendCommand_MM(datapool, outLength, CardDataBuffer, &BufferLength);
						
						isFound = true;

						MSR.CloseMSRDevice();

						break;
					}
				}
			}
		}		
	}

	if(!isFound)
		MessageBox("Fail to detect device!", _T("Error"), MB_OK);

	if (CardDataBuffer[0] == 6)
		cmdSucceed = true;


	// Show command text
	StrResponse = _T("CMD: ");
	for (i=0; i<outLength; i++)
	{
		StrTmp.Format("%02X ", datapool[i]);
		StrResponse += StrTmp;
	}

	// MiniMag series with NAK package
	if ((nReader == 3) || (nReader == 6) || (nReader == 8))
	{
		for (i=BufferLength; i>0; i--)
		{
			// NAK package
			if ((CardDataBuffer[i-8] == 0x15) && (CardDataBuffer[i-7] == 0) && (CardDataBuffer[i-6] == 0) && (CardDataBuffer[i-5] == 0)
				 && (CardDataBuffer[i-4] == 0) && (CardDataBuffer[i-3] == 0) && (CardDataBuffer[i-2] == 0) && (CardDataBuffer[i-1] == 0))
			{				
				i = i-7;
			}

			else if (CardDataBuffer[i-1] != 0)
			{
				End = i;
				break;
			}
		}

	}
	
	else
	{
		for (i=BufferLength; i>0; i--)
		{
			if (CardDataBuffer[i-1] != 0)
			{
				End = i;
				break;
			}
		}
	}

	ResponseLength = End;

	// Output all response
	StrResponse += _T("\r\nOUT: ");
	
	for (j=0; j<ResponseLength; j++)
	{
		StrTmp.Format("%02X ",CardDataBuffer[j]);
		StrResponse += StrTmp;
	}

	GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);

//	MSR.CloseMSRDevice();

	return cmdSucceed;
}

/**************************************************/
/* Events of Main Menu - General Setting
/**************************************************/
void CKeyInjectModuleDlg::OnMENUSetDefault() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x18;
	datapool[3] = 0x03;
	datapool[4] = 0x4A;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadConfiguration() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x1F;
	datapool[3] = 0x03;
	datapool[4] = 0x4C;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadFirmware() 
{
	bool cmdSucceed;
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x22;
	datapool[3] = 0x03;
	datapool[4] = 0x71;

	cmdSucceed = SendCommandRequest(datapool, outLength);

	if(cmdSucceed)
	{
		int i;
		CString StrResponse, StrTmp;
		
		// Get command request and response string
		GetDlgItem(IDC_RESP)->GetWindowText(StrResponse);

		// Append extra information+
		StrResponse += "\r\nFirmware Version: ";
		for (i=2; i<ResponseLength-2; i++)
		{
			StrTmp.Format("%C",CardDataBuffer[i]);
			StrResponse += StrTmp;
		}

		if (CardDataBuffer[i] != 3) // Check CardDataBuffer[ResponseLength-1] != ETX?  when LRC = 0
		{
			StrTmp.Format("%C",CardDataBuffer[i]);
			StrResponse += StrTmp;
		}


		// Output with extra information
		GetDlgItem(IDC_RESP)->SetWindowText(StrResponse);
	}
}

void CKeyInjectModuleDlg::OnMENUBeeperOff() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x11;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x72;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUBeeperLow() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x11;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x73;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUBeeperHigh() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x11;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x70;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMSREnableID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1A;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x78;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMSRDisableID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1A;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x79;

	SendCommandRequest(datapool, outLength);
}


void CKeyInjectModuleDlg::OnMENUReadBothDirections() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x7F;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadForwardDirection() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x7C;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUReadBackwardDirection() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x1D;
	datapool[3] = 0x01;
	datapool[4] = 0x33;
	datapool[5] = 0x03;
	datapool[6] = 0x7D;

	SendCommandRequest(datapool, outLength);
}


void CKeyInjectModuleDlg::OnHIDIDTMode() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x23;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0x40;

	cmdSucceed = SendCommandRequest(datapool, outLength);

	KBMode = 0;	// ID Tech USB HID Mode

	GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
}

void CKeyInjectModuleDlg::OnUSBKBMode() 
{
	bool cmdSucceed;
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x23;
	datapool[3] = 0x01;
	datapool[4] = 0x38;
	datapool[5] = 0x03;
	datapool[6] = 0x48;

	cmdSucceed = SendCommandRequest(datapool, outLength);

	KBMode = 1;	// ID Tech USB HID KB Mode
	
	GetDlgItem(IDC_SCRIPT)->ShowWindow(TRUE);
}


/**************************************************/
/* Events of Main Menu - MSR Security
/**************************************************/
void CKeyInjectModuleDlg::OnMENUSetPrePANClrDataID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x49;
	datapool[3] = 0x01;
	datapool[4] = 0x06;
	datapool[5] = 0x03;
	datapool[6] = 0x1C;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetPostPANClrDataID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4A;
	datapool[3] = 0x01;
	datapool[4] = 0x03;
	datapool[5] = 0x03;
	datapool[6] = 0x1A;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetMaskCharID() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4B;
	datapool[3] = 0x01;
	datapool[4] = 0x23;
	datapool[5] = 0x03;
	datapool[6] = 0x3B;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnSecurityLevID() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x7E;
	datapool[3] = 0x03;
	datapool[4] = 0x2D;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnGetDeviceSN() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x4e;
	datapool[3] = 0x03;
	datapool[4] = 0x1d;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMenuTdes() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0x2E;

	SendCommandRequest(datapool, outLength);

	bChecked = false;
	bDecryptMode = 1;	// DES Mode
}

void CKeyInjectModuleDlg::OnMenuAes() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x4C;
	datapool[3] = 0x01;
	datapool[4] = 0x32;
	datapool[5] = 0x03;
	datapool[6] = 0x2D;
	
	SendCommandRequest(datapool, outLength);

	bChecked = false;
	bDecryptMode = 2;	// AES mode
}



/**************************************************/
/* Events of Main Menu - USB KB Setting
/**************************************************/
void CKeyInjectModuleDlg::OnSetpollinginterval1() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x14;
	datapool[3] = 0x01;
	datapool[4] = 0x01;
	datapool[5] = 0x03;
	datapool[6] = 0x46;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetPollingInterval() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x14;
	datapool[3] = 0x01;
	datapool[4] = 0x0a;
	datapool[5] = 0x03;
	datapool[6] = 0x4d;

	SendCommandRequest(datapool, outLength);
}


void CKeyInjectModuleDlg::OnMENUSetUK() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x24;
	datapool[3] = 0x01;
	datapool[4] = 0x39;
	datapool[5] = 0x03;
	datapool[6] = 0x4E;

	SendCommandRequest(datapool, outLength);
}

void CKeyInjectModuleDlg::OnMENUSetUniversal() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x24;
	datapool[3] = 0x01;
	datapool[4] = 0x3a;
	datapool[5] = 0x03;
	datapool[6] = 0x4d;

	SendCommandRequest(datapool, outLength);
}


/**************************************************/
/* Events of Main Menu - Help
/**************************************************/
void CKeyInjectModuleDlg::OnMENUAbout() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();		
}


void CKeyInjectModuleDlg::OnActauth() 
{
	CString		StrTmp,StrOut;

	BYTE KSNTmp[10];
	BYTE KeyTmp[16];
	BYTE keyt[16];
	BYTE XORKey = 240; // F0
	BOOL bError = false;

	unsigned char stringKSN[10];

	const int outLength = 8;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x80;
	datapool[3] = 0x02;
	datapool[4] = 0x00;
	datapool[5] = 0x00;
	datapool[6] = 0x03;
	datapool[7] = 0xD1;

	SendCommandRequest(datapool, outLength);


	// Check KSN from response
	for(int i=0; i<10; i++) {
		KSNTmp[i] = CardDataBuffer[2 + i]; // skip first 2 bytes
		KSNglb[i] = KSNTmp[i];
	}

	// Update challenge
	for(i=0; i<16; i++)
		challenge[i] = CardDataBuffer[12 + i]; // skip first 2+10 bytes


	for(i=0; i<16; i++)
		keyt[i] = CardDataBuffer[12 + i]; // skip first 2+10 bytes

	// Decrypt 16 bytes data to get challenge1 and challenge2. 
	//Initial key
	if (!bIK)
	{
		m_str_initial_key = StrInitialKey;
		int len = m_str_initial_key.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
	}

	memcpy(stringKSN, KSNTmp,10);

	GetInitalKey(stringKSN, m_nderivation_key, m_ninitial_key);
		
	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);
	
	CurrentCryptoKey(0, m_ninitial_key, stringKSN, m_cryptoKey);

	for (i=0; i<16; i++)
		KeyTmp[i] = m_cryptoKey[i]^XORKey;


	if (bDecryptMode == 1) //TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

		TDES_Decryption(challenge, KeyTmp, init_vector, 16);
	
	}

	else //if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

		AES_Decryption(challenge, KeyTmp, init_vector, 16);	
	}
	
	// Verify if the last 2 bytes of Challenge 1 is the last 2 bytes of KSN
	for (i=8; i<10; i++)
	{
		if (KSNTmp[i] != challenge[i-2])
		{
			MessageBox("KSN does not match!");
			break;
		}
	}
}

void CKeyInjectModuleDlg::OnActrply() 
{
	BYTE KSNTmp[10];
	BYTE DataTmp[32];
	BYTE KeyTmp[16];
	BYTE LRC = 0;
	BYTE XORKey = 60; // 3C

	unsigned char stringKSN[10];

	const int outLength = 22;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x82;
	datapool[3] = 0x10;

	// 6-byte challenge 1
	for(int i=0; i<6; i++)
		DataTmp[i] = challenge[i];
	// 2-byte time information
	DataTmp[6] = 0x00;
	DataTmp[7] = 0x3C; // 60 seconds


	// Check KSN from response
	for(i=0; i<10; i++) {
		KSNTmp[i] = KSNglb[i];
	}

	//Initial key
	if (!bIK)
	{
		m_str_initial_key = StrInitialKey;
		int len = m_str_initial_key.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
	}

	memcpy(stringKSN, KSNTmp,10);

	GetInitalKey(stringKSN, m_nderivation_key, m_ninitial_key);

	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);

	CurrentCryptoKey(0, m_ninitial_key, stringKSN, m_cryptoKey);

	// challenge
	for(i=8; i<16; i++)
		DataTmp[i] = 0xAA;

	// XOR Key
	for(i=0; i<16; i++)
		KeyTmp[i] = XORKey ^ m_cryptoKey[i];

	
	if (bDecryptMode == 1)	//TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};

		TDES_Encryption(DataTmp, KeyTmp, init_vector, 8);
	}

	else //if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

		AES_Encryption(DataTmp, KeyTmp, init_vector, 16);
	}


	// Encrypted Challenge 
	for(i=0; i<16; i++)
		datapool[4 + i] = DataTmp[i];

	datapool[20] = 0x03;

	// calculate LRC
	for (i=0; i<21; i++)
		LRC ^= datapool[i];

	datapool[21] = LRC;


	SendCommandRequest(datapool, outLength);

	bActivation = true;	
}

void CKeyInjectModuleDlg::OnDeactrply() 
{
	BYTE KSNTmp[10];
	BYTE DataTmp_TDES[16];
	BYTE DataTmp_AES[16];
	BYTE KeyTmp[16];
	BYTE LRC;
	BYTE XORKey = 60; // 3C
	unsigned char  stringKSN[10];

	int i;
	
	BYTE datapool_TDES[14];
	BYTE datapool_AES[22];

	
	if (bDecryptMode == 1)	//TDES
	{
		datapool_TDES[0] = 0x02;
		datapool_TDES[1] = 0x53;
		datapool_TDES[2] = 0x81;
		datapool_TDES[3] = 0x08;

		// 7-byte challenge 2
		for(i=0; i<7; i++)
			DataTmp_TDES[i] = challenge[8 + i];
		
		DataTmp_TDES[7] = 0x01;
	}

	else					//AES
	{
		datapool_AES[0] = 0x02;
		datapool_AES[1] = 0x53;
		datapool_AES[2] = 0x81;
		datapool_AES[3] = 0x10;

		// 7-byte challenge 2
		for(i=0; i<7; i++)
			DataTmp_AES[i] = challenge[8 + i];
		
		DataTmp_AES[7] = 0x01;

		for(i=8; i<15; i++)
			DataTmp_AES[i] = 0;
	}

	// Check KSN from response
	for(i=0; i<10; i++) {
		KSNTmp[i] = KSNglb[i];
	}

	//Initial key
	if (!bIK)
	{
		m_str_initial_key = StrInitialKey;
		int len = m_str_initial_key.GetLength();

		for(i=0; i<len/2; i++)							
			m_nderivation_key[i] = asctohex(m_str_initial_key.GetAt(2*i),m_str_initial_key.GetAt(2*i+1));
	}


	memcpy(stringKSN, KSNTmp,10);

	GetInitalKey(stringKSN, m_nderivation_key, m_ninitial_key);

	//get the m_cryptoKey
	memset(m_cryptoKey, 0, 16);

	CurrentCryptoKey(0, m_ninitial_key, stringKSN, m_cryptoKey);

	// XOR Key
	for(i=0; i<16; i++)
		KeyTmp[i] = XORKey ^ m_cryptoKey[i];


	if (bDecryptMode == 1)	//TDES
	{
		unsigned char init_vector[8] = {0,0,0,0,0,0,0,0};
	
		TDES_Encryption(DataTmp_TDES, KeyTmp, init_vector, 8);

		for(i=0; i<8; i++)
			datapool_TDES[4 + i] = DataTmp_TDES[i];

		datapool_TDES[12] = 0x03;

		LRC = 0;
		// calculate LRC
		for (i=0; i<13; i++)
			LRC ^= datapool_TDES[i];

		datapool_TDES[13] = LRC;

		SendCommandRequest(datapool_TDES, 14);

	}
	
	else //if (bDecryptMode == 2) //AES
	{
		unsigned char init_vector[16] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		
		AES_Encryption(DataTmp_AES, KeyTmp, init_vector, 16);

		for(i=0; i<16; i++)
			datapool_AES[4 + i] = DataTmp_AES[i];

		datapool_AES[20] = 0x03;

		LRC = 0;
		// calculate LRC
		for (i=0; i<21; i++)
			LRC ^= datapool_AES[i];

		datapool_AES[21] = LRC;

		SendCommandRequest(datapool_AES, 22);
	}

	bActivation = false;	
}

void CKeyInjectModuleDlg::OnStatus() 
{
	const int outLength = 5;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x52;
	datapool[2] = 0x83;
	datapool[3] = 0x03;
	datapool[4] = 0xD0;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMENUOldEncryptionFormat() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x85;
	datapool[3] = 0x01;
	datapool[4] = 0x30;
	datapool[5] = 0x03;
	datapool[6] = 0xE6;

	SendCommandRequest(datapool, outLength);			
}

void CKeyInjectModuleDlg::OnMENUNewEncryptionFormat() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x85;
	datapool[3] = 0x01;
	datapool[4] = 0x31;
	datapool[5] = 0x03;
	datapool[6] = 0xE7;

	SendCommandRequest(datapool, outLength);	
}

void CKeyInjectModuleDlg::OnMENUForceEncryptAllTracks() 
{
	const int outLength = 7;
	BYTE datapool[outLength];

	datapool[0] = 0x02;
	datapool[1] = 0x53;
	datapool[2] = 0x84;
	datapool[3] = 0x01;
	datapool[4] = 0x07;
	datapool[5] = 0x03;
	datapool[6] = 0xD0;

	SendCommandRequest(datapool, outLength);		
}

void CKeyInjectModuleDlg::CheckReaderConnection()  
{
	bool bConnected = false;

	BYTE BufferTmp1[50], BufferTmp2[50];
	ULONG	BufferLength1 = 50, BufferLength2 = 50;
		
	INTERFACE_TYPE emMyItfType; 
	ULONG emMyItfType1; 
	INTERFACE_TYPE emMyItfType2;
	CString strDevName;
	int		m_ulDevIndex = 0;
	
	emMyItfType1 = '1';
	emMyItfType2 = ITF_TYPE_USB_HID;


	CMSRItfUSBHID	MSR(emMyItfType2);
	for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
	{
		if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
		{
			if(emMyItfType != emMyItfType2)			
				continue;
			else
			{
				if(MSR.OpenMSRDevice(m_ulDevIndex))
				{					
					KBMode = 0; // USB HID
					GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
					bConnected = true;					

					if (!bChecked)
					{
					
						if (nReader == 1)		// SecureMag USB HID						
							StrReaderStatus = _T("SecureMag USB HID Reader Connected ");
						
						else if (nReader == 2)	// ValueMag USB HID						
							StrReaderStatus = _T("ValueMag USB HID Reader Connected ");

						else if (nReader == 3)	// MiniMag II USB HID						
							StrReaderStatus = _T("MiniMag II USB HID Reader Connected ");

						else if (nReader == 7)	// ValueMag MagTek USB HID						
							StrReaderStatus = _T("ValueMag USB HID (Other Format) Reader Connected ");

						else if (nReader == 8)	// MiniMag II MagTek USB HID						
							StrReaderStatus = _T("MiniMag II USB HID (Other Format) Reader Connected ");


						// SecureMag USB HID
						if (nReader == 1)			
						{
							const int outLength = 5;
							BYTE datapool[outLength];

							datapool[0] = 0x02;
							datapool[1] = 0x52;
							datapool[2] = 0x7E;
							datapool[3] = 0x03;
							datapool[4] = 0x2D;

							MSR.SendCommand(datapool, outLength, BufferTmp1, &BufferLength1);
								
							if(BufferLength1)
							{
								if (BufferTmp1[4] < 0x33)	// Encryption is off
								{
									bDecryptMode = 0;
									StrReaderStatus += _T(" ( No Encryption )");
								}

								else						// Encryption is on
								{
									datapool[0] = 0x02;
									datapool[1] = 0x52;
									datapool[2] = 0x4C;
									datapool[3] = 0x03;
									datapool[4] = 0x1F;
									MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);

									if(BufferLength2)
									{
										if (BufferTmp2[4] == 0x31)			// TDES
										{
											bDecryptMode = 1;
											StrReaderStatus += _T(" ( TDES Encryption Enabled )");
										}

										else if ( BufferTmp2[4] == 0x32)	// AES
										{
											bDecryptMode = 2;
											StrReaderStatus += _T(" ( AES Encryption Enabled )");
										}
									}
								}
							}
						}

						bChecked = true;
					}
				}			
			}
		}
	}
	
	if(m_ulDevIndex >= 50){
		emMyItfType2 = ITF_TYPE_USB_HID_KB;
		
		CMSRItfUSBHID	MSR(emMyItfType2);
		for(m_ulDevIndex = 0; m_ulDevIndex < 50; m_ulDevIndex++)
		{
			if(MSR.EnumMSRDevice2(&emMyItfType, m_ulDevIndex, strDevName))
			{
				if(emMyItfType != emMyItfType2)
					continue;
				else
				{
					if(MSR.OpenMSRDevice(m_ulDevIndex))
					{		
						KBMode = 1; // USB KB						
						bConnected = true;

						if (!bChecked)
						{						
							if (nReader == 4)		// SecureMag USB KB						
								StrReaderStatus = _T("SecureMag USB KB Reader Connected ");
						
							else if (nReader == 5)	// ValueMag USB KB						
								StrReaderStatus = _T("ValueMag USB KB Reader Connected ");

							else if (nReader == 6)	// MiniMag II USB KB						
								StrReaderStatus = _T("MiniMag II USB KB Reader Connected ");

							if (nReader == 4)		// SecureMag USB KB	
							{
								const int outLength = 5;
								BYTE datapool[outLength];

								datapool[0] = 0x02;
								datapool[1] = 0x52;
								datapool[2] = 0x7E;
								datapool[3] = 0x03;
								datapool[4] = 0x2D;

								MSR.SendCommand(datapool, outLength, BufferTmp1, &BufferLength1);
									
								if(BufferLength1)
								{
									if (BufferTmp1[4] < 0x33)	// Encryption is off
									{
										bDecryptMode = 0;
										StrReaderStatus += _T(" ( No Encryption )");
										GetDlgItem(IDC_SCRIPT)->ShowWindow(FALSE);
									}

									else						// Encryption is on
									{
										datapool[0] = 0x02;
										datapool[1] = 0x52;
										datapool[2] = 0x4C;
										datapool[3] = 0x03;
										datapool[4] = 0x1F;
										MSR.SendCommand(datapool, outLength, BufferTmp2, &BufferLength2);

										if(BufferLength2)
										{
											if (BufferTmp2[4] == 0x31)			// TDES
											{
												bDecryptMode = 1;
												StrReaderStatus += _T(" ( TDES Encryption Enabled )");
											}

											else if ( BufferTmp2[4] == 0x32)	// AES
											{
												bDecryptMode = 2;
												StrReaderStatus += _T(" ( AES Encryption Enabled )");
											}
										}

										GetDlgItem(IDC_SCRIPT)->ShowWindow(TRUE);
									}
								}
							}

							bChecked = true;
						}						
					}
				}
			}
		}		
	}
	
	if (!bConnected)
	{
		MSR.CloseMSRDevice();
		bChecked = false;
		StrReaderStatus = _T("Please Connect MagSwipe Reader!");
	}


}

void CKeyInjectModuleDlg::OnSynchronize() 
{
	CheckReaderConnection();
	GetDlgItem(IDC_READER_STATUS)->SetWindowText(StrReaderStatus);
	
}
