// Thread.cpp : implementation file
//

#include "stdafx.h"
#include "keyinjectmodule.h"
#include "Thread.h"
#include "msritf.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern 	CString StrHID_Data;
extern 	BYTE HID_Data[1024];
extern 	int HID_Data_Length;
/////////////////////////////////////////////////////////////////////////////
// CThread

IMPLEMENT_DYNCREATE(CThread, CWinThread)

CThread::CThread()
{
}

CThread::~CThread()
{
}

BOOL CThread::InitInstance()
{
	// TODO:  perform and per-thread initialization here
	return TRUE;
}

int CThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CThread, CWinThread)
	//{{AFX_MSG_MAP(CThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
    ON_THREAD_MESSAGE ( WM_THREADMESSAGE, MessageHandler )
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CThread message handlers

 void CThread::MessageHandler(WPARAM, LPARAM)
 {
  	unsigned char DataBuffer[1000];
	int DataLength=0;     
  
	CString strResponse,StringTmp;
	int LastByte;

	DWORD bRet1 = NULL, bRet2  = NULL, bRet3  = NULL, bRet4  = NULL, bRet5  = NULL;


	while(1)
	{

										// SecureMag USBHID
		bRet1 = m_USBHID.LookDevice(IDTECH_VENDOR_ID, IDTECH_SM_USBHID_PID);
		
		if (!bRet1)						// ValueMag USBHID
			bRet2 = m_USBHID2.LookDevice(IDTECH_VENDOR_ID, IDTECH_VM_USBHID_PID);
		
		if ((!bRet1)&&(!bRet2))			// MiniMag II USBHID	
			bRet3 = m_USBHID.LookDevice(IDTECH_VENDOR_ID, IDTECH_MM_USBHID_PID);
		

		if ((!bRet1)&&(!bRet2)&&(!bRet3)) // MiniMag II MagTek USBHID		
			bRet4 = m_USBHID2.LookDevice(IDTECH_VENDOR_ID, MM_MAGTEK_USBHID_PID);
		

		if ((!bRet1)&&(!bRet2)&&(!bRet3)&&(!bRet4)) // ValueMag MagTek USBHID		
			bRet5 = m_USBHID2.LookDevice(IDTECH_VENDOR_ID, VM_MAGTEK_USBHID_PID);
		

		if (bRet1)
		{
			DataLength = m_USBHID.GetReport(DataBuffer,5000);

			if (DataLength)
			{
				strResponse = _T("");
				LastByte = DataLength-1;

				for (int i=DataLength-1; i>0; i--)		
				{
					if (DataBuffer[i] == 0)
						LastByte = i;
					else
						break;
				}

				for (i=1; i<LastByte; i++)
				{	
					HID_Data[i] = DataBuffer[i];
					StringTmp.Format("%02X",DataBuffer[i]);
					strResponse += StringTmp;				
				}					
				
				HID_Data_Length = LastByte;

				StrHID_Data = "";
				StrHID_Data += strResponse;	
				m_Dlg.Received_HID_Data();	
			}
		}	
		
		else if (bRet2)
		{
			DataLength = m_USBHID2.GetReport(DataBuffer,5000);

			if (DataLength)
			{
				strResponse = _T("");
				LastByte = DataLength-1;

				for (int i=DataLength-1; i>0; i--)		
				{
					if (DataBuffer[i] == 0)
						LastByte = i;
					else
						break;
				}

				for (i=1; i<LastByte; i++)
				{	
					HID_Data[i] = DataBuffer[i];
					StringTmp.Format("%02X",DataBuffer[i]);
					strResponse += StringTmp;				
				}					
				
				HID_Data_Length = LastByte;

				StrHID_Data = "";
				StrHID_Data += strResponse;	
				m_Dlg.Received_HID_Data();	
			}
		}	

		else if (bRet3)
		{
			DataLength = m_USBHID.GetReport(DataBuffer,5000);

			if (DataLength)
			{
				strResponse = _T("");
				LastByte = DataLength-1;

				for (int i=DataLength-1; i>0; i--)		
				{
					if (DataBuffer[i] == 0)
						LastByte = i;
					else
						break;
				}

				for (i=1; i<LastByte; i++)
				{	
					HID_Data[i] = DataBuffer[i];
					StringTmp.Format("%02X",DataBuffer[i]);
					strResponse += StringTmp;				
				}					
				
				HID_Data_Length = LastByte;

				StrHID_Data = "";
				StrHID_Data += strResponse;	
				m_Dlg.Received_HID_Data();	
			}
		}	

		else if (bRet4)
		{
			DataLength = m_USBHID2.GetReport(DataBuffer,5000);

			if (DataLength)
			{
				strResponse = _T("");
				LastByte = DataLength-1;

				for (int i=DataLength-1; i>0; i--)		
				{
					if (DataBuffer[i] == 0)
						LastByte = i;
					else
						break;
				}

				for (i=1; i<LastByte; i++)
				{	
					HID_Data[i] = DataBuffer[i];
					StringTmp.Format("%02X",DataBuffer[i]);
					strResponse += StringTmp;				
				}					
				
				HID_Data_Length = LastByte;

				StrHID_Data = "";
				StrHID_Data += strResponse;	
				m_Dlg.Received_HID_Data();	
			}
		}
		
		else if (bRet5)
		{
			DataLength = m_USBHID2.GetReport(DataBuffer,5000);

			if (DataLength)
			{
				strResponse = _T("");
				LastByte = DataLength-1;

				for (int i=DataLength-1; i>0; i--)		
				{
					if (DataBuffer[i] == 0)
						LastByte = i;
					else
						break;
				}

				for (i=1; i<LastByte; i++)
				{	
					HID_Data[i] = DataBuffer[i];
					StringTmp.Format("%02X",DataBuffer[i]);
					strResponse += StringTmp;				
				}					
				
				HID_Data_Length = LastByte;

				StrHID_Data = "";
				StrHID_Data += strResponse;	
				m_Dlg.Received_HID_Data();	
			}
		}			
	}
 }